#include <bits/stdc++.h>

static const int alphabet = 26;
static int id = 0;
const int maxn = 110;
const int maxsum = 1010;
const int maxk = 1010;
const int maxl = 110;
const int MOD = (int)1e9 + 7;

int n, k;
char s[maxl];
char word[maxn];
int dp[maxsum][maxk];

struct node {
  node *children[alphabet];
  node *back[alphabet];
  std::vector<node*> autocompletions;
  int nid;

  node() {
    for (int i = 0; i < alphabet; i++) {
      children[i] = NULL;
      back[i] = NULL;
    }
    nid = id++;
  }
};

node *root = new node();
node *nodes[maxsum];

void addAutocompletion(node *n, node *f) {
  if (n != root && n->autocompletions.size() < 3) {
    n->autocompletions.push_back(f);
  }
}

node* add(node *n, const char *s) {
  char c = *s;
  if (c == '\0') {
    return n;
  }
  if (n->children[c - 'a'] == NULL) {
    n->children[c - 'a'] = new node();
    nodes[n->children[c - 'a']->nid] = n->children[c - 'a'];
    n->children[c - 'a']->back[c - 'a'] = n;
  }
  node *f = add(n->children[c - 'a'], s + 1);
  addAutocompletion(n, f);
  return f;
}

void addValue(int &where, int add) {
  if ((where += add) >= MOD) {
    where -= MOD;
  }
}

int main() {
  scanf("%d", &n);
  nodes[0] = root;
  for (int i = 0; i < n; i++) {
    scanf("%s", word);
    add(root, word);
  }
  scanf("%s", s);
  scanf("%d", &k);
  int len = strlen(s);
  node *cur = root;
  int ii;
  for (ii = 0; ii < len; ii++) {
    int c = s[ii] - 'a';
    if (cur->children[c] == NULL) {
      break;
    }
    cur = cur->children[c];
  }
  int suffLen = len - ii;
  dp[0][0] = 1;
  for (int i = 0; i < k; i++) {
    for (int nid = 0; nid < id; nid++) {
      if (dp[i][nid] == 0) {
        continue;
      }
      for (int c = 0; c < alphabet; c++) {
        if (nodes[nid]->back[c] != NULL) {
          addValue(dp[i + 1][nodes[nid]->back[c]->nid], dp[i][nid]);
        }
        if (nodes[nid]->children[c] != NULL) {
          addValue(dp[i + 1][nodes[nid]->children[c]->nid], dp[i][nid]);
        }
      }
      for (node *autocompletion : nodes[nid]->autocompletions) {
        addValue(dp[i + 1][autocompletion->nid], dp[i][nid]);
      }
    }
  }
  int res = 0;
  for (int i = 0; i <= k - suffLen; i++) {
    addValue(res, dp[i][cur->nid]);
  }
  printf("%d\n", res);
  return 0;
}
