#include <iostream>
#include <fstream>
#include <set>
#include "testlib.h"
using namespace std;

const int MAXNM = 1000;

bool table[MAXNM][MAXNM];

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);
    int first = atoi(argv[1]);
    int n = rnd.next(901, first) % 100 + 901;
    int m = rnd.next(901, 1000);
    int q = 1000000;
    cout << n << ' ' << m << ' ' << q << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            bool b = rnd.next(0, 1);
            cout << (char)('0' + b);
            table[i][j] = b;
        }
        cout << '\n';
    }
    set<int> hors[MAXNM];
    set<int> verts[MAXNM];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (!table[i][j]) {
                hors[i].insert(j);
                verts[j].insert(i);
            }
    while (q--) {
        int x1,y1,d = rnd.next(1, 4);
        while (1) {
            x1 = rnd.next(0, n - 1);
            y1 = rnd.next(0, m - 1);
            if (table[x1][y1])
                break;
        }
        cout << x1 << ' ' << y1 << ' ' << d << '\n';
        if (!table[x1][y1])
            continue;
        int x2 = x1, y2 = y1;
        if (d == 1) {
            auto it = verts[y1].lower_bound(x1);
            if (it != verts[y1].begin())
                x2 = *--it;
        }
        else if (d == 2) {
            auto it = hors[x1].lower_bound(y1);
            if (it != hors[x1].end())
                y2 = *it;
        }
        else if (d == 3) {
            auto it = verts[y1].lower_bound(x1);
            if (it != verts[y1].end())
                x2 = *it;
        }
        else {
            auto it = hors[x1].lower_bound(y1);
            if (it != hors[x1].begin())
                y2 = *--it;
        }
        table[x1][y1] = 0;
        hors[x1].insert(y1);
        verts[y1].insert(x1);
        table[x2][y2] = 1;
        hors[x2].erase(y2);
        verts[y2].erase(x2);
    }
    return 0;
}

