#include <stdio.h>
#include <iostream>
using namespace std;

const int MAX = 1005;
int c[MAX][MAX];
int treeX[MAX][4 * MAX];
int treeY[MAX][4 * MAX];

void initTree(bool f, int k, int v, int l, int r) {
    if (r - l == 1) {
    	if (f) {
        	treeX[k][v] = c[k][l];
        } else {
        	treeY[k][v] = c[l][k];
        }
        return;
    }
    initTree(f, k, 2 * v, l, (l + r) / 2);
    initTree(f, k, 2 * v + 1, (l + r) / 2, r);
    if (f) {
    	treeX[k][v] = treeX[k][2 * v] + treeX[k][2 * v + 1];
    } else {
    	treeY[k][v] = treeY[k][2 * v] + treeY[k][2 * v + 1];
    }
}
 
void Set(bool f, int k, int v, int l, int r, int ind, int x) {
    if (ind < l || ind >= r) return;
    if (r - l == 1) {
    	if (f) {
        	treeX[k][v] = x;
        } else {
        	treeY[k][v] = x;
        }
        return;
    }
    Set(f, k, 2 * v, l, (l + r) / 2, ind, x);
    Set(f, k, 2 * v + 1, (l + r) / 2, r, ind, x);
    if (f) {
    	treeX[k][v] = treeX[k][2 * v] + treeX[k][2 * v + 1];
    } else {
    	treeY[k][v] = treeY[k][2 * v] + treeY[k][2 * v + 1];
    }
}

int Sum(bool f, int k, int v, int l, int r, int x, int y) {
    if (x >= r || y <= l) return 0;
    if (l >= x && r <= y) {
    	if (f) {
    		return treeX[k][v];
    	} else {
    		return treeY[k][v];
    	}
    }
    return Sum(f, k, 2 * v, l, (l + r) / 2, x, y) + Sum(f, k, 2 * v + 1, (l + r) / 2, r, x, y);
}

int main() {
	// freopen("input.txt", "r", stdin);

	int n, m, q;
	scanf("%d%d%d", &n, &m, &q);
	char s;
	scanf("%c", &s);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			scanf("%c", &s);
			if (s == '0')
				c[i][j] = 0;
			else
				c[i][j] = 1;
		}
		scanf("%c", &s);
	}

	for (int i = 0; i < n; ++i) {
		initTree(true, i, 1, 0, m);
	}
	for (int i = 0; i < m; ++i) {
		initTree(false, i, 1, 0, n);
	}

	// cout << Sum(true, 1, 1, 0, m, 1, 2) << endl;

	for (int i = 0; i < q; ++i) {
		int x, y, d;
		scanf("%d%d%d", &x, &y, &d);
		// if (Sum(true, x, 1, 0, m, y, y + 1) == 0) {
		// 	continue;
		// }
		if (c[x][y] == 0) {
			continue;
		}

		if (d == 1) {
			if (Sum(false, y, 1, 0, n, 0, x + 1) == x + 1) {
				continue;
			}
			int l = -1, r = x - 1;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (Sum(false, y, 1, 0, n, mid + 1, x + 1) == x - mid) {
					r = mid;
				} else {
					l = mid;
				}
			}
			Set(false, y, 1, 0, n, x, 0);
			Set(false, y, 1, 0, n, r, 1);
			Set(true, x, 1, 0, m, y, 0);
			Set(true, r, 1, 0, m, y, 1);
			c[x][y] = 0;
			c[r][y] = 1;
		} else if (d == 2) {
			if (Sum(true, x, 1, 0, m, y, m) == m - y) {
				continue;
			}
			int l = y + 1, r = m;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (Sum(true, x, 1, 0, m, y, mid) == mid - y) {
					l = mid;
				} else {
					r = mid;
				}
			}
			Set(true, x, 1, 0, m, y, 0);
			Set(true, x, 1, 0, m, l, 1);
			Set(false, y, 1, 0, n, x, 0);
			Set(false, l, 1, 0, n, x, 1);
			c[x][y] = 0;
			c[x][l] = 1;
		} else if (d == 3) {
			if (Sum(false, y, 1, 0, n, x, n) == n - x) {
				continue;
			}
			int l = x + 1, r = n;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (Sum(false, y, 1, 0, n, x, mid) == mid - x) {
					l = mid;
				} else {
					r = mid;
				}
			}
			Set(false, y, 1, 0, n, x, 0);
			Set(false, y, 1, 0, n, l, 1);
			Set(true, x, 1, 0, m, y, 0);
			Set(true, l, 1, 0, m, y, 1);
			c[x][y] = 0;
			c[l][y] = 1;
		} else if (d == 4) {
			if (Sum(true, x, 1, 0, m, 0, y + 1) == y + 1) {
				continue;
			}
			int l = -1, r = y - 1;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (Sum(true, x, 1, 0, m, mid + 1, y + 1) == y - mid) {
					r = mid;
				} else {
					l = mid;
				}
			}
			Set(true, x, 1, 0, m, y, 0);
			Set(true, x, 1, 0, m, r, 1);
			Set(false, y, 1, 0, n, x, 0);
			Set(false, r, 1, 0, n, x, 1);
			c[x][y] = 0;
			c[x][r] = 1;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			printf("%d", c[i][j]);
		}
		printf("\n");
	}

	return 0;
}