#include <iostream>
#include <set>
using namespace std;

size_t used_mem = 0;
char mem[100000005];

void * operator new(size_t sz) {
    void * res = mem + used_mem;
    used_mem += sz;
    return res;
}

void operator delete(void * p) {}

const int MAXNM = 1001;

char s[MAXNM];

bool table[MAXNM][MAXNM];
set<int> hors[MAXNM];
set<int> verts[MAXNM];

template <typename T>
T next_int() {
    T x = 0, p = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ');
    if(ch == '-') {
        p = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        x = x * 10 + (ch - '0');
        ch = getchar();
    }
    return p * x;
}

int main() {
    int n, m, q;
    n = next_int<int>();
    m = next_int<int>();
    q = next_int<int>();
    scanf("\n");
    for (int i = 0; i < n; i++) {
        gets(s);
        for (int j = 0; j < m; j++) {
            table[i][j] = s[j] - '0';
        }
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (!table[i][j]) {
                hors[i].insert(j);
                verts[j].insert(i);
            }
    while (q--) {
        int x1 = next_int<int>();
        int y1 = next_int<int>();
        int d = next_int<int>();
        if (!table[x1][y1])
            continue;
        int x2 = x1, y2 = y1;
        if (d == 1) {
            auto it = verts[y1].lower_bound(x1);
            if (it != verts[y1].begin())
                x2 = *--it;
        }
        else if (d == 2) {
            auto it = hors[x1].lower_bound(y1);
            if (it != hors[x1].end())
                y2 = *it;
        }
        else if (d == 3) {
            auto it = verts[y1].lower_bound(x1);
            if (it != verts[y1].end())
                x2 = *it;
        }
        else {
            auto it = hors[x1].lower_bound(y1);
            if (it != hors[x1].begin())
                y2 = *--it;
        }
        table[x1][y1] = 0;
        hors[x1].insert(y1);
        verts[y1].insert(x1);
        table[x2][y2] = 1;
        hors[x2].erase(y2);
        verts[y2].erase(x2);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            printf("%c", (char)(table[i][j] + '0'));
        }
        printf("\n");
    }
    return 0;
}

