#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

typedef long long ll;

using namespace std;

const int MAXN = 1000;
int cur_test = -1;


string itoa(int x) 
{
    stringstream ss;           
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int a, int b) 
{
    startTest(cur_test++);
    cout << a << ":" << b << endl;
}

void gen_rand(int maxx)
{
    write_test(rnd.next(maxx + 1), rnd.next(maxx + 1));  
}

void gen_rand_equal(int maxx)
{
    int a = rnd.next(maxx + 1);
    write_test(a, a);  
}

void gen_rand_special(int maxx)
{
    int a = rnd.next(maxx);
    write_test(a + 1, a);  
}

void gen_rand_special2(int maxx)
{
    int a = rnd.next(maxx - 2);
    write_test(a + 3, a);  
}



int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
            write_test(i, j);
    for (int i = 10; i <= MAXN; i *= 10)
    {
        gen_rand(i);
        gen_rand_equal(i);
        gen_rand_special(i);
        gen_rand_special2(i);
    }
    write_test(MAXN, MAXN);
    write_test(MAXN - 1, MAXN);
    write_test(MAXN, MAXN - 3);
    return 0;
}

