#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <ctime>

using namespace std;

inline void print_ans(const vector<pair<int, int>> &x, int i, int type = 1) {
    cout << type << '\n' << i << ' ';
    for (int j = 0; j < i; ++j) {
        cout << x[j].second + 1 << ' ';
    }
    cout << '\n' << x.size() - i << ' ';
    for (int j = i; j < x.size(); ++j) {
        cout << x[j].second + 1 << ' ';
    }
}

int main() {
    time_t start_time = time(nullptr);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, a, b;
    scanf("%d%d%d", &n, &a, &b);
    vector<pair<int, int>> x(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        scanf("%d", &x[i].first);
        x[i].second = i;
        sum += x[i].first;
    }

    if (sum > a + b) {
        cout << -1;
        return 0;
    }

    vector<pair<int, int>> order2;
    int i2 = -1;
    auto kek = std::mt19937(std::random_device()());

    srand(1488);
    while (time(nullptr) - start_time < 0.9) {
        shuffle(x.begin(), x.end(), kek);
        int sum1 = 0;
        bool has1 = false;
        int i;
        for (i = 0; i < n; ++i) {
            if (sum1 + x[i].first > a) break;
            sum1 += x[i].first;
            if (x[i].second == 0) has1 = true;
        }

        if (sum1 <= a && (sum - sum1) <= b) {
            if (has1) {
                print_ans(x, i);
                return 0;
            }
            if (i2 == -1) {
                i2 = i;
                order2 = x;
            }
        }
    }

    if (i2 != -1) {
        print_ans(order2, i2, 2);
    } else {
        cout << -1;
    }
    return 0;
}

/*

3 4 3
3 2 2

 */