#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int MAXN = 1e6 + 5;
vector<int> graph[MAXN];
int sz[MAXN];
const int SZ = 10;

struct node {
    int y;
    int x, sz;
    int l, r;
    node() : y(0), x(0), sz(0), l(0), r(0) {}
    node(int _x) : y(rnd(0, INF)), x(_x), sz(1), l(0), r(0) {}
};

vector<node> treap;

int add_node(int x) {
    treap.puba(node(x));
    return szof(treap) - 1;
}

void upd(int v) {
    int vl = treap[v].l, vr = treap[v].r;
    treap[v].sz = treap[vl].sz + 1 + treap[vr].sz;
}

void t_merge(int vl, int vr, int& v) {
    if (vl == 0) {
        v = vr;
        return;
    }
    if (vr == 0) {
        v = vl;
        return;
    }
    if (treap[vl].y > treap[vr].y) {
        t_merge(treap[vl].r, vr, treap[vl].r);
        v = vl;
        upd(v);
    } else {
        t_merge(vl, treap[vr].l, treap[vr].l);
        v = vr;
        upd(v);
    }
}

void t_split(int v, int& vl, int& vr, int val) {
    if (v == 0) {
        vl = vr = 0;
        return;
    }
    if (treap[v].x <= val) {
        t_split(treap[v].r, treap[v].r, vr, val);
        vl = v;
        upd(vl);
    } else {
        t_split(treap[v].l, vl, treap[v].l, val);
        vr = v;
        upd(vr);
    }
}

int lower_than(int v, int val) {
    if (!v) {
        return 0;
    }
    if (treap[v].x < val) {
        return treap[treap[v].l].sz + 1 + lower_than(treap[v].r, val);
    } else {
        return lower_than(treap[v].l, val);
    }
}

ll calc_inv(int v1, int v2) {
    if (!v1) {
        return 0;
    }
    return lower_than(v2, treap[v1].x) + calc_inv(treap[v1].l, v2) + calc_inv(treap[v1].r, v2);
}

void t_insert(int& v, int nv) {
    if (!v) {
        v = nv;
        return;
    }
    if (treap[v].y > treap[nv].y) {
        if (treap[v].x < treap[nv].x) {
            t_insert(treap[v].r, nv);
        } else {
            t_insert(treap[v].l, nv);
        }
    } else {
        t_split(v, treap[nv].l, treap[nv].r, treap[nv].x);
        v = nv;
    }
    upd(v);
}

void t_merge2(int v1, int& v2) {
    if (!v1) {
        return;
    }
    int vl = treap[v1].l, vr = treap[v1].r;
    treap[v1] = node(treap[v1].x);
    t_insert(v2, v1);
    t_merge2(vl, v2);
    t_merge2(vr, v2);
}

ll cost[SZ][SZ];
int from[1 << SZ];
ll d[1 << SZ];
int ind[(1 << SZ) + 3];

ll ans = 0;

int dfs(int v) {
    vector<int> children;
    for (int to : graph[v]) {
        children.puba(dfs(to));
        ans += treap[children.back()].sz - lower_than(children.back(), v);
    }
    int bpv = 1 << szof(graph[v]);
    for (int i = 0; i < szof(graph[v]); ++i) {
        for (int j = i + 1; j < szof(graph[v]); ++j) {
            if (treap[children[i]].sz < treap[children[j]].sz) {
                ll tmp = calc_inv(children[i], children[j]);
                cost[j][i] = tmp;
                cost[i][j] = (ll) treap[children[i]].sz * treap[children[j]].sz - tmp;
            } else {
                ll tmp = calc_inv(children[j], children[i]);
                cost[i][j] = tmp;
                cost[j][i] = (ll) treap[children[i]].sz * treap[children[j]].sz - tmp;
            }
        }
    }
    /*
    cerr << v << ":" << endl;
    for (int i = 0; i < szof(graph[v]); ++i) {
        for (int j = 0; j < szof(graph[v]); ++j) {
            cerr << cost[i][j] << " ";
        }
        cerr << endl;
    }
    */
    fill(d, d + bpv, INFL);
    d[0] = 0;
    for (int i = 0; i < bpv; ++i) {
        for (int j = 0; j < szof(graph[v]); ++j) {
            if (!((1 << j) & i)) {
                ll val = d[i];
                for (int k = 0; k < szof(graph[v]); ++k) {
                    if ((1 << k) & i) {
                        val += cost[j][k];
                    }
                }
                if (d[i | (1 << j)] > val) {
                    d[i | (1 << j)] = val;
                    from[i | (1 << j)] = i;
                }
            }
        }
    }
    //cerr << "d " << d[bpv - 1] << endl;
    ans += d[bpv - 1];
    int pos = bpv - 1;
    vector<int> newc(szof(graph[v]));
    int c = szof(graph[v]) - 1;
    while (pos) {
        newc[c] = graph[v][ind[pos ^ from[pos]]];
        --c;
        pos = from[pos];
    }
    graph[v] = newc;

    int cur = add_node(v);
    for (auto q : children) {
        if (treap[cur].sz < treap[q].sz) {
            int tmp = q;
            t_merge2(cur, tmp);
            cur = tmp;
        } else {
            t_merge2(q, cur);
        }
    }
    return cur;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);

    treap.puba(node());
    
    for (int i = 0; i < SZ; ++i) {
        ind[1 << i] = i;
    }

    int n, root;
    scanf("%d%d", &n, &root);
    --root;

    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        for (int j = 0; j < num; ++j) {
            int v;
            scanf("%d", &v);
            --v;
            graph[i].puba(v);
        }
    }
    
    dfs(root);

    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        cout << szof(graph[i]) << " ";
        for (int to : graph[i]) {
            cout << to + 1 << " ";
        }
        cout << "\n";
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}