import random
import math
random.seed("basic02/gasorposorp")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(6, 6, [[1, 1, 5, 4], [3, 2, 6, 5], [2, 6, 4, 6]])

    def generate_min_tests(self):
        self.print_test(1, 1, [[1, 1, 1, 1], [1, 1, 1, 1], [1, 1, 1, 1]])
        self.print_test(2, 2, [[1, 1, 1, 1], [1, 1, 1, 1], [1, 1, 1, 1], [1, 1, 1, 2], [1, 1, 2, 1], [1, 2, 1, 2]])
        self.print_test(2, 2, [[1, 1, 1, 1], [1, 1, 2, 2], [1, 1, 1, 1], [1, 1, 1, 2], [1, 1, 2, 1], [1, 2, 1, 2]])
        self.print_test(2, 2, [[1, 1, 1, 1], [1, 1, 1, 2], [2, 1, 2, 2], [1, 1, 1, 2], [1, 1, 2, 1], [1, 2, 1, 2]])

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxm, maxq):
        n = random.randint(1, maxn)
        m = random.randint(1, maxm)
        q = random.randint(1, maxq)
        qs = []
        for i in range(q):
            x1 = random.randint(1, n)
            y1 = random.randint(1, m)
            x2 = random.randint(x1, n)
            y2 = random.randint(y1, m)
            qs.append([x1, y1, x2, y2])
        self.print_test(n, m, qs)

    def generate_max_tests(self, maxn, maxm, maxq):
        qs = []
        for i in range(maxn // 2):
            qs.append([i + 1, i + 1, maxn - i, maxn // 2 + i])
        self.print_test(maxn, maxn, qs)
        random.shuffle(qs)
        self.print_test(maxn, maxn, qs)
        qs = []
        for i in range(0, maxn // 2, 2):
            qs.append([i + 1, i + 1, maxn - i, maxn // 2 + i])
        self.print_test(maxn, maxn, qs)
        random.shuffle(qs)
        self.print_test(maxn, maxn, qs)
        
    def print_test(self, n, m, qs):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(n, m, len(qs), file=test_file)
        for q in qs:
            print(' '.join(map(str, q)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [1, 3, 5, 10, 50, 100, 10**3]
        for n in ns:
            for m in ns:
                maxq = min(1000, n * m)
                self.generate_random_test(n, m, maxq)
        self.generate_max_tests(10**3, 10**3, 10**3)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
