#include <bits/stdc++.h>

const int maxn = 1010;
const int maxq = maxn * maxn;

int n, m, q;
std::set<int> xs[maxn], ys[maxn];
std::vector<std::pair<int, int>> v[maxq];

int field[maxn][maxn];
int parent[maxq];
int size[maxq];
int id;
int u;

void merge(int y1, int x1, int y2, int x2) {
    if (field[y1][x1] == 0 || field[y2][x2] == 0) {
        return;
    }
    int c1 = field[y1][x1];
    int c2 = field[y2][x2];
    while (c1 != parent[c1]) {
        c1 = parent[c1];
    }
    while (c2 != parent[c2]) {
        c2 = parent[c2];
    }
    if (c1 == c2) {
        return;
    }
    u--;
    if (size[c1] > size[c2]) {
        size[c1] += size[c2];
        parent[c2] = c1;
    } else {
        size[c2] += size[c1];
        parent[c1] = c2;
    }
}

void change(int y, int x) {
    field[y][x] = ++id;
    parent[id] = id;
    size[id] = 1;
    u++;
    merge(y, x, y - 1, x);
    merge(y, x, y + 1, x);
    merge(y, x, y, x - 1);
    merge(y, x, y, x + 1);
}

void add(int i, int x1, int y1, int x2, int y2) {
    if (y1 == y2) {
        auto it = ys[y1].lower_bound(x1);
        while (it != ys[y1].end() && *it <= x2) {
            v[i].push_back({y1, *it});
            auto it2 = it;
            it2++;
            xs[*it].erase(y1);
            ys[y1].erase(*it);
            it = it2;
        }
    } else {
        auto it = xs[x1].lower_bound(y1);
        while (it != xs[x1].end() && *it <= y2) {
            v[i].push_back({*it, x1});
            auto it2 = it;
            it2++;
            ys[*it].erase(x1);
            xs[x1].erase(*it);
            it = it2;
        }
    }
}

int main() {
    scanf("%d%d%d", &n, &m, &q);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            ys[i].insert(j);
            xs[j].insert(i);
        }
    }
    for (int i = 1; i <= q; i++) {
        int y1, x1, y2, x2;
        scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
        add(i, x1, y1, x1, y2);
        if (x1 < x2) {
            add(i, x2, y1, x2, y2);
        }
        if (x1 + 1 < x2) {
            add(i, x1 + 1, y1, x2 - 1, y1);
            if (y1 < y2) {
                add(i, x1 + 1, y2, x2 - 1, y2);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (const auto &x : ys[i]) {
            v[q + 1].push_back({i, x});
        }
    }
    std::vector<int> r;
    for (int i = q + 1; i >= 1; i--) {
        for (const auto &j : v[i]) {
            change(j.first, j.second);
        }
        r.push_back(u);
    }
    for (int i = q - 1; i >= 0; i--) {
        printf("%d\n", r[i]);
    }
}
