import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.stream.IntStream;

public class Check implements ru.ifmo.testlib.Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        BigInteger sum = inf.nextBigInteger();

        int jCnt = ans.nextInt();
        BigInteger[] jAns = new BigInteger[jCnt];
        for (int i = 0; i < jCnt; i++) {
            jAns[i] = ans.nextBigInteger();
        }
        boolean jOk = check(jAns, sum);
        if (!jOk) {
            throw new Outcome(Type.FAIL, "Invalid jury solution");
        }

        int pCnt;
        BigInteger[] pAns;
        try {
            pCnt = ouf.nextInt();
            if (pCnt <= 0) throw new Outcome(Type.PE, "Malformed array length");
//            pAns = new BigInteger[pCnt];
            ArrayList<BigInteger> bis = new ArrayList<>();
            for (int i = 0; i < pCnt; i++) {
                bis.add(ouf.nextBigInteger());
            }
            pAns = new BigInteger[bis.size()];
            pAns = bis.toArray(pAns);
        } catch (Exception e) {
            throw new Outcome(Type.PE, "Invalid output file");
        }

        boolean ok = check(pAns, sum);
        if (!ok) {
            throw new Outcome(Type.WA,
                    "The answer given by contestant is incorrect");
        }
        throw new Outcome(Type.OK, "okay");
    }

    private static boolean check(BigInteger[] nums, BigInteger sum) {
        BigInteger cur = BigInteger.ZERO;
        for (BigInteger num : nums) {
            if (num.compareTo(BigInteger.ZERO) <= 0) return false;
            if (!isNice(num)) return false;
            cur = cur.add(num);
        }
        return cur.equals(sum);
    }

    private static boolean isNice(BigInteger x) {
        BigInteger d = x.mod(BigInteger.TEN);
        while (x.compareTo(BigInteger.ZERO) > 0) {
            if (!d.equals(x.mod(BigInteger.TEN))) return false;
            x = x.divide(BigInteger.TEN);
        }
        return true;
    }
}
