#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 100;
const int MAXC = 1000;

struct point {
    int x, y;
    point() : x(0), y(0) {}
    point(int _x, int _y) : x(_x), y(_y) {}
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
    bool operator<(point p) const {
        if (x != p.x) {
            return x < p.x;
        }
        return y < p.y;
    }
};

int sign(int num) {
    return num > 0 ? 1 : (num < 0 ? -1 : 0);
}

int predicate(point p1, point p2) {
    return sign(p1.x * p2.y - p1.y * p2.x);
}

bool intersect(point a, point b, point c, point d) {
    int val1 = predicate(a - b, c - b) * 
               predicate(a - b, d - b);
    int val2 = predicate(c - d, a - d) *
               predicate(c - d, b - d);
    if (val1 <= 0 && val2 <= 0 && (val1 != 0 || val2 != 0)) {
        return true;
    }
    return false;
}

double get_ang(double ang1, double ang2) {
    double tmp = ang2 - ang1;
    if (tmp < 0) {
        tmp += PI * 2;
    }
    return tmp;
}

vector<point> coords;
vector<pii> edges;

bool check(point p1, point p2) {
    for (pii e : edges) {
        if (intersect(coords[e.ff], coords[e.ss], p1, p2)) {
            return false;
        }
    }
    return true;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc > 4);

    int n = atoi(argv[1]);
    int k = atoi(argv[2]);
    int ca = atoi(argv[3]);
    int cb = atoi(argv[4]);

    int minr = 100;
    int dr = (MAXC - minr) / k;
    vector<vector<int>> layers;
    coords.resize(n);
    set<point> have;
    vector<double> angle(n);
    vector<int> order;
    for (int i = 0; i < n; ++i) {
        order.puba(i);
    }
    shuffle(bend(order));
    int cnt = 0;

    for (int i = 0; i < k; ++i) {
        int r1 = dr * i + minr;
        int r2 = r1 + dr / 10;
        int now = n / k;
        if (i < n % k) {
            ++now;
        }
        layers.puba({});
        for (int j = 0; j < now; ++j) {
            int ind = order[cnt++];
            do {
                int r = rnd.next(r1, r2);
                double ang = 2 * PI * rnd.next(0, INF - 1) / INF;
                int x = cos(ang) * r, y = sin(ang) * r;
                
                coords[ind] = point(x, y);
            } while (have.count(coords[ind]));
            have.insert(coords[ind]);
            angle[ind] = atan2(coords[ind].y, coords[ind].x);
            layers.back().puba(ind);
        }

        sort(bend(layers.back()), [&](int a, int b) {
            return angle[a] < angle[b];
        });

        for (int j = 0; j < now; ++j) {
            int next = (j + 1) % now;
            int ind1 = layers.back()[j];
            int ind2 = layers.back()[next];
            
            if (check(coords[ind1], coords[ind2])) {
                edges.puba({ind1, ind2});
            }
        }
    }


    for (int i = 0; i < k - 1; ++i) {
        int c = 0;
        for (int j = 0; j < szof(layers[i]); ++j) {
            while (c < szof(layers[i + 1]) && angle[layers[i + 1][c]] < angle[layers[i][j]]) {
                int prev = (j - 1 + szof(layers[i])) % szof(layers[i]);
                if (check(coords[layers[i][prev]], coords[layers[i + 1][c]])) {
                    edges.emplace_back(layers[i][prev], layers[i + 1][c]);
                }
                if (check(coords[layers[i][j]], coords[layers[i + 1][c]])) {
                    edges.emplace_back(layers[i][j], layers[i + 1][c]);
                }
                ++c;
            }
        }
        while (c < szof(layers[i + 1])) {
            int prev = szof(layers[i]) - 1;
            int j = 0;
            if (check(coords[layers[i][prev]], coords[layers[i + 1][c]])) {
                edges.emplace_back(layers[i][prev], layers[i + 1][c]);
            }
            if (check(coords[layers[i][j]], coords[layers[i + 1][c]])) {
                edges.emplace_back(layers[i][j], layers[i + 1][c]);
            }
            ++c;
        }
    }

    cout << n << " " << szof(edges) << " " << max(k, 2) << " " << ca << " " << cb << "\n";
    for (point p : coords) {
        cout << p.x << " " << p.y << "\n";
    }

    shuffle(bend(edges));
    for (pii e : edges) {
        if (rnd.next(0, 1)) {
            swap(e.ff, e.ss);
        }
        cout << e.ff + 1 << " " << e.ss + 1 << "\n";
    }

    /*
    for (int i = 0; i < k; ++i) {
        for (int v : layers[i]) {
            cerr << v + 1 << " ";
        }   
        cerr << endl;
    }
    */
    
    int last = -1;
    for (int i = 0; i < k; ++i) {
        int next = layers[i][rnd.next(0, szof(layers[i]) - 1)];
        while (next == last) {
            next = layers[i][rnd.next(0, szof(layers[i]) - 1)];
        }
        cout << next + 1;
        last = next;
        if (i < k - 1) {
            cout << " ";
        }
    }

    if (k == 1) {
        int next = rnd.next(0, n - 1);
        while (next == last) {
            next = rnd.next(0, n - 1);
        }
        cout << " " << next + 1;
    }

    cout << "\n";

    return 0;
}