#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 100;
const int MAXC = 1000;

struct point {
    int x, y;
    point() : x(0), y(0) {}
    point(int _x, int _y) : x(_x), y(_y) {}
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
    bool operator<(point p) const {
        if (x != p.x) {
            return x < p.x;
        }
        return y < p.y;
    }
};

int sign(int num) {
    return num > 0 ? 1 : (num < 0 ? -1 : 0);
}

int predicate(point p1, point p2) {
    return sign(p1.x * p2.y - p1.y * p2.x);
}

bool intersect(point a, point b, point c, point d) {
    int val1 = predicate(a - b, c - b) * 
               predicate(a - b, d - b);
    int val2 = predicate(c - d, a - d) *
               predicate(c - d, b - d);
    if (val1 <= 0 && val2 <= 0 && (val1 != 0 || val2 != 0)) {
        return true;
    }
    return false;
}

double get_ang(double ang1, double ang2) {
    double tmp = ang2 - ang1;
    if (tmp < 0) {
        tmp += PI * 2;
    }
    return tmp;
}

vector<point> coords;
vector<pii> edges;

bool check(point p1, point p2) {
    for (pii e : edges) {
        if (intersect(coords[e.ff], coords[e.ss], p1, p2)) {
            return false;
        }
    }
    return true;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc > 4);

    int n = atoi(argv[1]);
    int k = atoi(argv[2]);
    int ca = atoi(argv[3]);
    int cb = atoi(argv[4]);

    set<point> have;
    coords.puba(point(0, 0));
    have.insert(point(0, 0));

    for (int i = 0; i < n; ++i) {
        point p = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
        while (have.count(p)) {
            p = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
        }
        coords.puba(p);
        have.insert(p);
    }

    for (int i = 1; i < n; ++i) {
        edges.puba({0, i});
    }

    for (int i = 1; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (check(coords[i], coords[j])) {
                edges.puba({i, j});
            }
        }
    }

    cout << n << " " << szof(edges) << " " << k << " " << ca << " " << cb << "\n";

    for (int i = 0; i < n; ++i) {
        cout << coords[i].x << " " << coords[i].y << "\n";
    }

    for (auto e : edges) {
        cout << e.ff + 1 << " " << e.ss + 1 << "\n";
    }

    int last = -1;
    for (int i = 0; i < k; ++i) {
        int next = rnd.next(0, n - 1);
        while (next == last) {
            next = rnd.next(0, n - 1);
        }
        cout << next + 1;
        last = next;
        if (i < k - 1) {
            cout << " ";
        }
    }
    cout << "\n";
    cerr << clock() << endl;
    return 0;
}