#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 8000, MAXK = 50;
const int MAXC = 1000, MAXCOEF = 1000000000;

struct point {
    int x, y;
    point() : x(0), y(0) {}
    point(int _x, int _y) : x(_x), y(_y) {}
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
};

int sign(int num) {
    return num > 0 ? 1 : (num < 0 ? -1 : 0);
}

int predicate(point p1, point p2) {
    return sign(p1.x * p2.y - p1.y * p2.x);
}

bool intersect(point a, point b, point c, point d) {
    int val1 = predicate(a - b, c - b) * 
               predicate(a - b, d - b);
    int val2 = predicate(c - d, a - d) *
               predicate(c - d, b - d);
    if (val1 <= 0 && val2 <= 0 && (val1 != 0 || val2 != 0)) {
        return true;
    }
    return false;
}

vector<int> graph[MAXN];
bool used[MAXN];

int dfs(int v) {
    used[v] = true;
    for (int to : graph[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    return 0;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(0, n * 3, "m");
    inf.readSpace();
    int k = inf.readInt(2, MAXK, "k");
    inf.readSpace();
    int ca = inf.readInt(1, MAXCOEF, "ca");
    inf.readSpace();
    int cb = inf.readInt(1, MAXCOEF, "cb");
    inf.readEoln();

    set<pii> have;
    vector<point> coords;
    for (int i = 0; i < n; ++i) {
        int x = inf.readInt(-MAXC, MAXC, "x");
        inf.readSpace();
        int y = inf.readInt(-MAXC, MAXC, "y");
        inf.readEoln();
        coords.puba(point(x, y));
        ensuref(!have.count({x, y}), "points must be different");
        have.insert({x, y});
    }

    vector<pii> edges;
    have.clear();
    for (int i = 0; i < m; ++i) {
        int a = inf.readInt(1, n, "a") - 1;
        inf.readSpace();
        int b = inf.readInt(1, n, "b") - 1;
        inf.readEoln();
        ensuref(a != b, "there's a loop");
        if (a > b) {
            swap(a, b);
        }
        ensuref(!have.count({a, b}), "there's a twin edges");
        have.insert({a, b});
        edges.puba({a, b});
        graph[a].puba(b);
        graph[b].puba(a);
    }

    vector<int> order;
    int prev = -1;
    int first = -1;
    for (int i = 0; i < k; ++i) {
        int v = inf.readInt(1, n, "v") - 1;
        if (first == -1) {
            first = v;
        }
        order.puba(v);
        if (i < k - 1) {
            inf.readSpace();
        }
        if (i) {
            ensuref(prev != v, "consecutive goals must be different");
        }
        prev = v;
    }
    ensuref(first != prev, "consecutive goals must be different");
    inf.readEoln();
    inf.readEof();

    dfs(0);

    for (int i = 0; i < n; ++i) {
        ensuref(used[i], "graph must be connected");
    }

    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            if (intersect(coords[edges[i].ff], coords[edges[i].ss], coords[edges[j].ff], coords[edges[j].ss])) {
                ensuref(false, "edges #%d and #%d intersect", i + 1, j + 1);
            }
        }
    }

    return 0;
}